#
# spec file for package xapian-core
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           xapian-core
Version:        1.2.21
Release:        3.5
Summary:        The Xapian Probabilistic Information Retrieval Library
License:        GPL-2.0
Group:          Productivity/Databases/Servers
Url:            http://www.xapian.org/
Source0:        http://www.oligarchy.co.uk/xapian/%{version}/%{name}-%{version}.tar.xz
Source1:        http://www.oligarchy.co.uk/xapian/%{version}/%{name}-%{version}.tar.xz.asc
Source2:        %{name}.keyring
Source3:        baselibs.conf
BuildRequires:  automake
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  libuuid-devel
BuildRequires:  pkg-config
BuildRequires:  xz
BuildRequires:  zlib-devel
Requires:       libxapian22 = %{version}
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Xapian is an Open Source Probabilistic Information Retrieval Library. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications

%package -n libxapian22
Summary:        Xapian search engine libraries
Group:          Development/Libraries/C and C++

%description -n libxapian22
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
libraries for applications using Xapian functionality

%package -n libxapian-devel
Summary:        Files needed for building packages which use Xapian
Group:          Development/Libraries/C and C++
Requires:       gcc-c++
Requires:       libuuid-devel
Requires:       libxapian22 = %{version}
Requires:       zlib-devel

%description -n libxapian-devel
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for building packages which use Xapian

%package doc
Summary:        Documentation for Xapian-core libraries
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}

%description doc
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for building packages which use Xapian

%package examples
Summary:        Examples for Xapian-core libraries
Group:          Development/Libraries/C and C++
Requires:       %{name} = %{version}

%description examples
Xapian is an Open Source Probabilistic Information Retrieval framework. It
offers a highly adaptable toolkit that allows developers to easily add advanced
indexing and search facilities to applications. This package provides the
files needed for building packages which use Xapian

%prep
%setup -q

%build
%configure \
%ifarch i586
      --disable-sse \
%endif
      --docdir=%{_docdir}/%{name}/

make %{?_smp_mflags}

%install
make DESTDIR=%{buildroot} docdatadir=%{_docdir}/%{name} install %{?_smp_mflags}
rm -rf examples/{.libs,.deps,.dirstamp,*.o,quest,delve,simplesearch,simpleexpand,simpleindex,copydatabase,xapian-metadata}
cp -vr examples  %{buildroot}%{_docdir}/%{name}/
find . -name \*.spec -delete
install -m 644 AUTHORS COPYING ChangeLog INSTALL README NEWS HACKING PLATFORMS ChangeLog.examples %{buildroot}%{_docdir}/%{name}
%fdupes %{buildroot}%{_docdir}/%{name}

%post -n libxapian22 -p /sbin/ldconfig

%postun -n libxapian22 -p /sbin/ldconfig

%files
%defattr(-, root, root)
%dir %{_docdir}/%{name}
%{_docdir}/%{name}/AUTHORS
%{_docdir}/%{name}/COPYING
%{_docdir}/%{name}/ChangeLog
%{_docdir}/%{name}/README
%{_docdir}/%{name}/INSTALL
%{_docdir}/%{name}/NEWS
%{_docdir}/%{name}/HACKING
%{_docdir}/%{name}/PLATFORMS
%{_docdir}/%{name}/ChangeLog.examples
%{_bindir}/xapian-tcpsrv
%{_bindir}/xapian-progsrv
%{_bindir}/quest
%{_bindir}/delve
%{_bindir}/copydatabase
%{_bindir}/simpleindex
%{_bindir}/simplesearch
%{_bindir}/simpleexpand
%{_bindir}/xapian-compact
%{_bindir}/xapian-check
%{_bindir}/xapian-inspect
%{_bindir}/xapian-chert-update
%{_bindir}/xapian-metadata
%{_bindir}/xapian-replicate
%{_bindir}/xapian-replicate-server
%{_mandir}/man1/xapian-check.1*
%{_mandir}/man1/xapian-inspect.1*
%{_mandir}/man1/copydatabase.1*
%{_mandir}/man1/delve.1*
%{_mandir}/man1/quest.1*
%{_mandir}/man1/xapian-compact.1*
%{_mandir}/man1/xapian-config.1*
%{_mandir}/man1/xapian-progsrv.1*
%{_mandir}/man1/xapian-tcpsrv.1*
%{_mandir}/man1/xapian-chert-update.1*
%{_mandir}/man1/xapian-metadata.1*
%{_mandir}/man1/xapian-replicate.1*
%{_mandir}/man1/xapian-replicate-server.1*

%files -n libxapian22
%defattr(-, root, root)
%{_libdir}/libxapian.so.*

%files -n libxapian-devel
%defattr(-, root, root)
%{_bindir}/xapian-config
%{_includedir}/xapian
%{_includedir}/xapian.h
%{_libdir}/libxapian.so
%{_libdir}/libxapian.a
%{_libdir}/libxapian.la
%{_datadir}/aclocal/xapian.m4
%dir %{_libdir}/cmake/
%{_libdir}/cmake/xapian/
%{_libdir}/pkgconfig/xapian-core.pc

%files doc
%defattr(-, root, root)
%{_docdir}/%{name}/*.html
%{_docdir}/%{name}/apidoc*

%files examples
%defattr(-, root, root)
%{_docdir}/%{name}/examples/

%changelog
* Thu May 21 2015 tittiatcoke@gmail.com
- Update to 1.2.21
  * API:
    + QueryParser: Extend the set of characters allowed in the
    start of a range to be anything except for '(' and characters <= ' '.
  * matcher:
    + Reimplement OP_PHRASE for non-exact phrases.
    + Reimplement OP_NEAR - the new implementation consistently
    requires the terms to occur at different positions, and fixes
    some previously missed matches.
    + Fix a reversed check for picking the shorter position list
    for an exact phrase of two terms.
    + When matching an exact phrase, if a term doesn't occur where
    we want, use its actual position to advance the anchor term,
    rather than just checking the next position of the anchor term.
  * brass backend:
    + Fix cursor versioning to consider cancel() and reopen() as
    events where the cursor version may need incrementing,
    and flag the current cursor version as used when a cursor is rebuilt.
    + Avoid using file descriptions < 3 for writable database tables,
    as it risks corruption if some code in the same process tries
    to write to stdout or stderr without realising it is closed.
  * chert backend:
    + Fix cursor versioning to consider cancel() and reopen() as
    events where the cursor version may need incrementing,
    and flag the current cursor version as used when a cursor is rebuilt.
    + Avoid using file descriptions < 3 for writable database tables,
    as it risks corruption if some code in the same process tries
    to write to stdout or stderr without realising it is closed.
  * flint backend:
    + Fix cursor versioning to consider cancel() and reopen() as
    events where the cursor version may need incrementing,
    and flag the current cursor version as used when a cursor is rebuilt.
  * remote backend:
    + Fix sort by value when multiple databases are in use and one or
    more are remote.
  * build system:
    + The compiler ABI check in the public API headers now issues a
    warning (instead of an error) for an ABI mismatch for ABI versions
    2 and later (which means GCC >= 3.4).
    + xapian-config,xapian-core.pc: When compiling with xlC on AIX, the
    reported --cxxflags/--cflags now include -D_LARGE_FILES=1 as this
    is defined for the library, and defining it changes the ABI of
    std::string with this compiler, so it must also be defined when
    building code using the Xapian API.
    + xapian-core.pc: Include --enable-runtime-pseudo-reloc in --libs
    output for mingw and cygwin, like xapian-config does.
    + xapian-core.pc: Fix include directory reported by `pkg-config --cflags`.
    + xapian-config: Fix typo so cached result of test in is_uninstalled()
    is actually used on subsequent calls.
    + configure: Changes in 1.2.19 broke the custom macro we use to probe
    for supported compiler flags such that the flags never got used.
    + configure: Set default value for AUTOM4TE before AC_OUTPUT so the
    default will actually get used.
    + soaktest: Link with libtool's '-no-install' or '-no-fast-install',
    like we already do for other test programs, which means that libtool
    doesn't need to generate shell script wrappers for them on most platforms.
  * documentation:
    + API documentation: Minor wording tweaks and formatting improvements.
    + docs/deprecation.rst: Add deprecation of omindex --preserve-nonduplicates
    which happened in 1.2.4.
    + HACKING: libtool 2.4.6 is now used for bootstrapping snapshots and releases.
  * tools:
    + xapian-compact: Make sure we open all the tables of input databases at the
    same revision.
    + xapian-metadata: Add 'list' subcommand to list all the metadata keys.
    + xapian-replicate: Fix connection timeout to be 10 seconds rather than 10000
    seconds (the incorrect timeout has been the case since 1.2.3).
    + xapian-replicate: Set SO_KEEPALIVE for xapian-replicate's connection to the
    master, and add command line option to allow setting socket-level timeouts
    (SO_RCVTIMEO and SO_SNDTIMEO) on platforms that support them.
    + xapian-replicate-server: Avoid potentially reading uninitialised data if a
    changeset file is truncated.
  * portability:
    + Add spaces between literal strings and macros which expand to literal strings
    for C++11 compatibility.
    + ValueCountMatchSpy::top_values_begin(): Fix the comparison function not to
    return true for two equal elements, which manifests as incorrect sorting in
    some cases when using clang's libc++ (which recent OS X versions do).
    + apitest: The adddoc5 testcase fails under clang due to an exception handling
    bug, so just #ifdef out the problematic part of the testcase when building
    with clang for now.
    + configure: Improve the probe for whether the test harness can use RTTI to
    work for IBM's xlC compiler (which defaults to not generating RTTI).
    + Use F_DUPFD where available to dup to a file descriptor which is >= 2, rather
    than calling dup() until we get one.
    + When unserialising a double, avoid reading one byte past the end of the
    serialised value.
    + When unserialising a double, add missing cast to unsigned char when we check
    if the value will fit in the double type.
    + Fix incorrect use of "delete" which should be "delete []".  This is
    undefined behaviour in C++, though the type is POD, so in practice this
    probably worked OK on many platforms.
- Drop patch 0001-backends-chert-chert_cursor.cc-backends-chert-chert_.patch
  due to upstream inclusion
* Sat May  2 2015 hrvoje.senjan@gmail.com
- Add 0001-backends-chert-chert_cursor.cc-backends-chert-chert_.patch
  from upstream (kde#341990, http://trac.xapian.org/ticket/675)
* Thu Mar 12 2015 mpluskal@suse.com
- Update to 1.2.20
  * chert backend
    + After splitting a block, we always insert the new block in
    the parent right after the block it was split from - there's
    no need to binary chop.
  * build system
    + Generate and install a file for pkg-config.
    + configure: Update link to cygwin FAQ in error message.
  * tools
    + xapian-check: For chert and brass, cross-check the position
    and postlist tables to detect positional data for non-existent
    documents.
  * portability
    + When locking a database for writing, use F_OFD_SETLK where
    available, which avoids having to fork() a child process to
    hold the lock.  This currently requires Linux kernel >= 3.15,
    but it has been submitted to POSIX so hopefully will be widely
    supported eventually.  Thanks to Austin Clements for pointing
    out this now exists.
    + Fix detection of fdatasync(), which appears to have been
    broken practically forever - this means we've probably been
    using fsync() instead, which probably isn't a big additional
    overhead.  Thanks to Vlad Shablinsky for helping with Mac
    OS X portability of this fix.
    + configure: Define MINGW_HAS_SECURE_API under mingw to get
    _putenv_s() declared in stdlib.h.
    + Use POSIX O_NONBLOCK in preference to O_NDELAY - the
    semantics of the latter differ between BSD and System V.
    + According to POSIX, strerror() may not be thread safe, so
    use alternative thread-safe ways to translate errno values
    where possible.
    + On Microsoft Windows, avoid defining EADDRINUSE, etc if
    they're already defined, and use WSAE* constants un-negated -
    they start from a high value so won't collide with E*
    constants.
* Fri Feb 20 2015 mpluskal@suse.com
- Tiny spec file cleanups
- Add gpg signature
* Tue Oct 21 2014 tittiatcoke@gmail.com
- Update to 1.2.19
  - API:
  * Xapian::BM5Weight:
    + Improve BM25 upper bound in the case when our wdf upper
    bound > our document length lower bound.
    + Pre-multiply termweight by (param_k1 + 1) rather than
    doing it for every weighted term in every document considered.
  - testsuite:
  * Don't report apparent leaks of fds opened on /dev/urandom
  - matcher:
  * Fix false matches reported for non-exact phrases in some cases.
  - build system:
  * For Sun's C++ compiler, pass -library=Crun separately since
    libtool looks for " -library=stlport4 " (with the spaces).
  * Remove .replicatmp (created by the test suite) upon "make clean".
  - documentation:
  * include/xapian/compactor.h: Fix formatting of doxygen comment.
  * HACKING: freecode no longer accepts updates, so drop that item
    from the release checklist.
  * docs/overview.rst: Add missing database path to example of using
    xapian-progsrv in a stub database file.
  - portability:
  * Suppress unused typedef warnings from debugging logging macros,
    which occur in functions which always exit via throwing an
    exception when compiling with recent versions of GCC or clang.
  * Fix debug logging code to compile with clang.
* Thu Sep 11 2014 hrvoje.senjan@gmail.com
- Add baselibs.conf, needed by baloo 32bit libraries
* Mon Apr 28 2014 tittiatcoke@gmail.com
- Switch the SSE instruction set of for x86 builds.
* Wed Jan 29 2014 hrvoje.senjan@gmail.com
- Update to 1.2.17
  - API:
  * Enquire::set_sort_by_relevance_then_value() and
    Enquire::set_sort_by_relevance_then_key(): Fix sense of reverse
    parameter.
  * BM25Weight: Fix case where (k1 == 0 || b == 0) but k2 != 0.
  * Unicode::tolower(): Fix to give correct results for U+01C5,
    U+01C8, U+01CB, and U+01F2
  - testsuite:
  * Automatically probe for and hook in eatmydata to the testsuite
    using the wrapper script it now includes.
  * Fix apitest to build when brass, chert or flint are disabled.
  - brass backend:
  * Fix handling of invalid block sizes passed to Xapian::Brass::open()
  - the size gets fixed as documented, but the uncorrected size
    was passed to the base file (and abort() was called if 0
    was passed).
  * Validate "dir_end" when reading a block.  (fixes #592)
  - chert backend:
  * Fix handling of invalid block sizes passed to Xapian::Chert::open()
  - the size gets fixed as documented, but the uncorrected size was
    passed to the base file (and abort() was called if 0 was passed).
  * Validate "dir_end" when reading a block.  (fixes #592)
  - flint backend:
  * Fix handling of invalid block sizes passed to Xapian::Flint::open()
  - the size gets fixed as documented, but the uncorrected size was
    passed to the base file (and abort() was called if 0 was passed).
  * Validate "dir_end" when reading a block.  (fixes #592)
  - build system:
  * configure: Improve reporting of GCC version.
  * Use -no-fast-install on platforms where -no-install causes
    libtool to emit a warning.
  * docs/Makefile.am: Fix handling of MAINTAINER_NO_DOCS.
  * Include UnicodeData.txt and the script to generate the unicode
    tables from it.
  - documentation:
  * postingsource.rst: Clarify a couple of points
  - portability:
  * Protect the ValueIterator::check() method against Mac OS X SDK
    headers which define a check() macro.
  * Fix warning from xlC compiler.
  * Avoid use of grep -e in configure, as /usr/bin/grep on Solaris
    doesn't support -e.
  * Fix check for flags which might be needed for ANSI mode for
    compilers called 'cxx'.
  * configure: Improve handling of Sun's C++ compiler - trick libtool
    into not adding -library=Cstd, and prefer -library=stdcxx4 if
    supported.  Explicitly add -library=Crun which seems to be required,
    even though the documentation suggests otherwise.
* Sun Dec 15 2013 hrvoje.senjan@gmail.com
- Update to 1.2.16
  - API:
  * PositionIterator,PostingIterator,TermIterator,ValueIterator:
    Don't segfault if skip_to() or check() is called on an iterator
    which is already at_end().
  * ValueCountMatchSpy: get_description() on a default-constructed
    ValueCountMatchSpy object no longer fails when xapian-core is
    built with --enable-log.
  * ValueCountMatchSpy: get_total() on a default-constructed
    ValueCountMatchSpy object now returns 0 rather than segfaulting.
  - brass backend:
  * When moving a cursor on a read-only table, check if the block we
    want is in the internal cursor.  We already do this for a
    writable table, as it is necessary for correctness, but it's a
    cheap check and may avoid asking the OS for a block we actually
    already have.
  * Correctly report the database as closed rather than
    'Bad file descriptor' in certain cases.
  * Reuse a cursor for reading values from valuestreams rather than
    creating a new one each time.  This can dramatically reduce the
    number of blocks redundantly reread when sorting by value.
    The rereads will generally get served from VM cache, but there's
    still an overhead to that.
  - chert backend:
  * When moving a cursor on a read-only table, check if the block
    we want is in the internal cursor. We already do this for a
    writable table, as it is necessary for correctness, but it's
    a cheap check and may avoid asking the OS for a block we actually
    already have.
  * Correctly report the database as closed rather than
    'Bad file descriptor' in certain cases.
  * Reuse a cursor for reading values from valuestreams rather than
    creating a new one each time.  This can dramatically reduce the
    number of blocks redundantly reread when sorting by value.
    The rereads will generally get served from VM cache, but there's
    still an overhead to that.
  - flint backend:
  * When moving a cursor on a read-only table, check if the block we
    want is in the internal cursor. We already do this for a writable
    table, as it is necessary for correctness, but it's a cheap check
    and may avoid asking the OS for a block we actually already have.
  * Correctly report the database as closed rather than
    'Bad file descriptor' in certain cases.
  - tools:
  * xapian-chert-update: Fix -b to work rather than always
    segfaulting (reported in http://bugs.debian.org/716484).
  * xapian-chert-update: The documented alias --blocksize for -b has
    never actually been supported, so just drop mentions of it
    from --help and the man page.
  - xapian-check:
  * Fix chert database check that first docid in each doclength
    chunk is more than the last docid in the previous chunk
  - previously this didn't actually work.
  * Fix database check not to falsely report "position table: Junk
    after position data" whenever there are 7 unused bits (7 is OK,
  * more* than 7 isn't).
  * Fix to report block numbers correctly for links within the B-tree.
  * If the METAINFO key is missing, only report it once per table.
  * Fix database consistency checking to always open all the tables
    at the same revision - not doing this could lead to false errors
    being reported after a commit interrupted by the process being
    killed or the machine crashing.
- Change tarball to xz. Added xz BuildRequires: xz for that purpose
* Thu May 30 2013 tittiatcoke@gmail.com
- Update to version 1.2.15
  * See http://svn.xapian.org/*checkout*/tags/1.2.15/xapian-core/NEWS
* Fri Dec 21 2012 mlin@suse.com
- Update to version 1.2.12
  * 1.2.11 had its library version information incorrectly set.
    This resulted in the shared library having an incorrect SONAME.
    This release has been made to fix this problem.
  * Fix issue with running AND, OR and XOR queries against a
    database with no documents in it - this was leading to a divide
    by zero, which led to MSet::get_matches_estimated() reporting
    2147483648 on i386.
  * Don't count unweighted subqueries of MultiAndPostList in
    percentage calculations, as OP_FILTER maps to MultiAndPostList
    now.  (ticket#590)
  * When compacting, if the output database is empty, don't write
    out a metainfo tag.  Take care not to divide by zero when
    computing the percentage size change for a table.
    (brass and chert backend)
  * Add new QueryParser::STEM_ALL_Z stemming strategy, which
    stems all terms and adds a Z prefix.
  * Add TermGenerator::set_stemming_strategy() method, with
    strategies which correspond to those of QueryParser.
  * Correct "BM25Weight" to "TradWeight" in exception message
    from TradWeight.
  * We were failing to call init() for user-defined Weight objects
    providing the term-independent weight.  These now get called
    with init(0.0).
  * Xapian::Auto::open_stub() now throws a Xapian::DatabaseOpeningError
    exception if the stub file can't be opened.  Previously we
    failed to check for this condition, which resulted in us
    treating the file as empty.
  * See http://svn.xapian.org/*checkout*/tags/1.2.12/xapian-core/NEWS
  * http://svn.xapian.org/*checkout*/tags/1.2.11/xapian-core/NEWS
  * http://svn.xapian.org/*checkout*/tags/1.2.10/xapian-core/NEWS
  * http://svn.xapian.org/*checkout*/tags/1.2.9/xapian-core/NEWS
* Thu Dec 29 2011 dmueller@suse.de
- update to 1.2.8:
  * Add support to TermGenerator and QueryParser for indexing and searching CJK
  text using n-grams.  Currently this is only enabled when the environmental
  variable XAPIAN_CJK_NGRAM is set to a non-empty value.
  * overview.html,quickstart.html: Fix several factual errors.
  * Improve documentation comments for several methods.
  * Add documentation for function parameters which didn't have it.
* Mon Nov 28 2011 coolo@suse.com
- avoid packaging files twice
* Tue Sep 13 2011 prusnak@opensuse.org
- updated to 1.2.7
* Tue May  3 2011 tittiatcoke@gmail.com
- Update to xapian-core-1.2.5
  * See http://svn.xapian.org/*checkout*/tags/1.2.5/xapian-core/NEWS
* Sat May 16 2009 tittiatcoke@gmail.com
- Updated to xapian-core-1.0.12
  + See http://svn.xapian.org/*checkout*/tags/1.0.12/xapian-core/NEWS
* Wed Mar 18 2009 tittiatcoke@gmail.com
- Updated to xapian-core-1.0.11
* Mon Nov 19 2007 mrueckert@suse.de
- added xapian-core-1.0.4_gcc43.patch:
  add missing includes for gcc 4.3
* Mon Nov 19 2007 mrueckert@suse.de
- update to 1.0.4
* Sun Jun 24 2007 mrueckert@suse.de
- update to 1.0.1
* Sun Apr  1 2007 mrueckert@suse.de
- update to 0.9.10
* Sat Nov 11 2006 mrueckert@suse.de
- update to 0.9.9:
  many smaller changes
* Sat Nov  4 2006 mrueckert@suse.de
- do not package .deps and .libs in the examples dir
* Sat Nov  4 2006 mrueckert@suse.de
- update to 0.9.8:
  many small fixes
